#ifndef _GP2X_h__
#define _GP2X_h__

//header start
#define GP2X_WIDTH 320
#define GP2X_HEIGHT 240

#ifdef _CAANOO_

#define GP2X_BUTTON_UP              11
#define GP2X_BUTTON_DOWN            12
#define GP2X_BUTTON_LEFT            13
#define GP2X_BUTTON_RIGHT           14
#define GP2X_BUTTON_UPLEFT          15
#define GP2X_BUTTON_UPRIGHT         16
#define GP2X_BUTTON_DOWNLEFT        17
#define GP2X_BUTTON_DOWNRIGHT       18
#define GP2X_BUTTON_CLICK           -3
#define GP2X_BUTTON_A               0
#define GP2X_BUTTON_B               2
#define GP2X_BUTTON_X               1
#define GP2X_BUTTON_Y               3
#define GP2X_BUTTON_L               4
#define GP2X_BUTTON_R               5
#define GP2X_BUTTON_START           9
#define GP2X_BUTTON_SELECT          8
#define GP2X_BUTTON_VOLUP           -1
#define GP2X_BUTTON_VOLDOWN         -2

#else

#define GP2X_BUTTON_UP              0
#define GP2X_BUTTON_DOWN            4
#define GP2X_BUTTON_LEFT            2
#define GP2X_BUTTON_RIGHT           6
#define GP2X_BUTTON_UPLEFT          1
#define GP2X_BUTTON_UPRIGHT         7
#define GP2X_BUTTON_DOWNLEFT        3
#define GP2X_BUTTON_DOWNRIGHT       5
#define GP2X_BUTTON_CLICK           18
#define GP2X_BUTTON_A               12
#define GP2X_BUTTON_B               13
#define GP2X_BUTTON_X               14
#define GP2X_BUTTON_Y               15
#define GP2X_BUTTON_L               10
#define GP2X_BUTTON_R               11
#define GP2X_BUTTON_START           8
#define GP2X_BUTTON_SELECT          9
#define GP2X_BUTTON_VOLUP           16
#define GP2X_BUTTON_VOLDOWN         17
//header end
//
# endif
  
#endif
